/**
 * Copyright (c) 2021 Contributors to the Eclipse Foundation
 *
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Do not edit: This file is generated by Xtext
 */
package org.eclipse.lsat.machine.teditor.serializer;

import com.google.inject.Inject;
import java.util.List;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.lsat.machine.teditor.services.MachineGrammarAccess;
import org.eclipse.xtext.IGrammarAccess;
import org.eclipse.xtext.RuleCall;
import org.eclipse.xtext.nodemodel.INode;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.AbstractElementAlias;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.GroupAlias;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.TokenAlias;
import org.eclipse.xtext.serializer.analysis.ISyntacticSequencerPDAProvider.ISynNavigable;
import org.eclipse.xtext.serializer.analysis.ISyntacticSequencerPDAProvider.ISynTransition;
import org.eclipse.xtext.serializer.sequencer.AbstractSyntacticSequencer;

@SuppressWarnings("all")
public abstract class AbstractMachineSyntacticSequencer extends AbstractSyntacticSequencer {

	protected MachineGrammarAccess grammarAccess;
	protected AbstractElementAlias match_Machine___PathAnnotationsKeyword_3_0_LeftCurlyBracketKeyword_3_1_RightCurlyBracketKeyword_3_3__q;
	protected AbstractElementAlias match_PeripheralType___ActionsKeyword_4_0_LeftCurlyBracketKeyword_4_1_RightCurlyBracketKeyword_4_3__q;
	protected AbstractElementAlias match_PeripheralType___SetPointsKeyword_5_0_LeftCurlyBracketKeyword_5_1_RightCurlyBracketKeyword_5_3_AxesKeyword_5_4_LeftCurlyBracketKeyword_5_5_RightCurlyBracketKeyword_5_7__q;
	protected AbstractElementAlias match_Peripheral___AxisPositionsKeyword_3_1_0_0_LeftCurlyBracketKeyword_3_1_0_1_RightCurlyBracketKeyword_3_1_0_3__q;
	protected AbstractElementAlias match_Peripheral___DistancesKeyword_3_1_7_0_LeftCurlyBracketKeyword_3_1_7_1_RightCurlyBracketKeyword_3_1_7_3__q;
	protected AbstractElementAlias match_Peripheral___LeftCurlyBracketKeyword_3_0_RightCurlyBracketKeyword_3_2__q;
	protected AbstractElementAlias match_Peripheral___PathsKeyword_3_1_8_0_LeftCurlyBracketKeyword_3_1_8_1_RightCurlyBracketKeyword_3_1_8_3__q;
	protected AbstractElementAlias match_Peripheral___SymbolicPositionsKeyword_3_1_1_0_LeftCurlyBracketKeyword_3_1_1_1_RightCurlyBracketKeyword_3_1_1_3__q;
	
	@Inject
	protected void init(IGrammarAccess access) {
		grammarAccess = (MachineGrammarAccess) access;
		match_Machine___PathAnnotationsKeyword_3_0_LeftCurlyBracketKeyword_3_1_RightCurlyBracketKeyword_3_3__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getMachineAccess().getPathAnnotationsKeyword_3_0()), new TokenAlias(false, false, grammarAccess.getMachineAccess().getLeftCurlyBracketKeyword_3_1()), new TokenAlias(false, false, grammarAccess.getMachineAccess().getRightCurlyBracketKeyword_3_3()));
		match_PeripheralType___ActionsKeyword_4_0_LeftCurlyBracketKeyword_4_1_RightCurlyBracketKeyword_4_3__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getPeripheralTypeAccess().getActionsKeyword_4_0()), new TokenAlias(false, false, grammarAccess.getPeripheralTypeAccess().getLeftCurlyBracketKeyword_4_1()), new TokenAlias(false, false, grammarAccess.getPeripheralTypeAccess().getRightCurlyBracketKeyword_4_3()));
		match_PeripheralType___SetPointsKeyword_5_0_LeftCurlyBracketKeyword_5_1_RightCurlyBracketKeyword_5_3_AxesKeyword_5_4_LeftCurlyBracketKeyword_5_5_RightCurlyBracketKeyword_5_7__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getPeripheralTypeAccess().getSetPointsKeyword_5_0()), new TokenAlias(false, false, grammarAccess.getPeripheralTypeAccess().getLeftCurlyBracketKeyword_5_1()), new TokenAlias(false, false, grammarAccess.getPeripheralTypeAccess().getRightCurlyBracketKeyword_5_3()), new TokenAlias(false, false, grammarAccess.getPeripheralTypeAccess().getAxesKeyword_5_4()), new TokenAlias(false, false, grammarAccess.getPeripheralTypeAccess().getLeftCurlyBracketKeyword_5_5()), new TokenAlias(false, false, grammarAccess.getPeripheralTypeAccess().getRightCurlyBracketKeyword_5_7()));
		match_Peripheral___AxisPositionsKeyword_3_1_0_0_LeftCurlyBracketKeyword_3_1_0_1_RightCurlyBracketKeyword_3_1_0_3__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getPeripheralAccess().getAxisPositionsKeyword_3_1_0_0()), new TokenAlias(false, false, grammarAccess.getPeripheralAccess().getLeftCurlyBracketKeyword_3_1_0_1()), new TokenAlias(false, false, grammarAccess.getPeripheralAccess().getRightCurlyBracketKeyword_3_1_0_3()));
		match_Peripheral___DistancesKeyword_3_1_7_0_LeftCurlyBracketKeyword_3_1_7_1_RightCurlyBracketKeyword_3_1_7_3__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getPeripheralAccess().getDistancesKeyword_3_1_7_0()), new TokenAlias(false, false, grammarAccess.getPeripheralAccess().getLeftCurlyBracketKeyword_3_1_7_1()), new TokenAlias(false, false, grammarAccess.getPeripheralAccess().getRightCurlyBracketKeyword_3_1_7_3()));
		match_Peripheral___LeftCurlyBracketKeyword_3_0_RightCurlyBracketKeyword_3_2__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getPeripheralAccess().getLeftCurlyBracketKeyword_3_0()), new TokenAlias(false, false, grammarAccess.getPeripheralAccess().getRightCurlyBracketKeyword_3_2()));
		match_Peripheral___PathsKeyword_3_1_8_0_LeftCurlyBracketKeyword_3_1_8_1_RightCurlyBracketKeyword_3_1_8_3__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getPeripheralAccess().getPathsKeyword_3_1_8_0()), new TokenAlias(false, false, grammarAccess.getPeripheralAccess().getLeftCurlyBracketKeyword_3_1_8_1()), new TokenAlias(false, false, grammarAccess.getPeripheralAccess().getRightCurlyBracketKeyword_3_1_8_3()));
		match_Peripheral___SymbolicPositionsKeyword_3_1_1_0_LeftCurlyBracketKeyword_3_1_1_1_RightCurlyBracketKeyword_3_1_1_3__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getPeripheralAccess().getSymbolicPositionsKeyword_3_1_1_0()), new TokenAlias(false, false, grammarAccess.getPeripheralAccess().getLeftCurlyBracketKeyword_3_1_1_1()), new TokenAlias(false, false, grammarAccess.getPeripheralAccess().getRightCurlyBracketKeyword_3_1_1_3()));
	}
	
	@Override
	protected String getUnassignedRuleCallToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		return "";
	}
	
	
	@Override
	protected void emitUnassignedTokens(EObject semanticObject, ISynTransition transition, INode fromNode, INode toNode) {
		if (transition.getAmbiguousSyntaxes().isEmpty()) return;
		List<INode> transitionNodes = collectNodes(fromNode, toNode);
		for (AbstractElementAlias syntax : transition.getAmbiguousSyntaxes()) {
			List<INode> syntaxNodes = getNodesFor(transitionNodes, syntax);
			if (match_Machine___PathAnnotationsKeyword_3_0_LeftCurlyBracketKeyword_3_1_RightCurlyBracketKeyword_3_3__q.equals(syntax))
				emit_Machine___PathAnnotationsKeyword_3_0_LeftCurlyBracketKeyword_3_1_RightCurlyBracketKeyword_3_3__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_PeripheralType___ActionsKeyword_4_0_LeftCurlyBracketKeyword_4_1_RightCurlyBracketKeyword_4_3__q.equals(syntax))
				emit_PeripheralType___ActionsKeyword_4_0_LeftCurlyBracketKeyword_4_1_RightCurlyBracketKeyword_4_3__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_PeripheralType___SetPointsKeyword_5_0_LeftCurlyBracketKeyword_5_1_RightCurlyBracketKeyword_5_3_AxesKeyword_5_4_LeftCurlyBracketKeyword_5_5_RightCurlyBracketKeyword_5_7__q.equals(syntax))
				emit_PeripheralType___SetPointsKeyword_5_0_LeftCurlyBracketKeyword_5_1_RightCurlyBracketKeyword_5_3_AxesKeyword_5_4_LeftCurlyBracketKeyword_5_5_RightCurlyBracketKeyword_5_7__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_Peripheral___AxisPositionsKeyword_3_1_0_0_LeftCurlyBracketKeyword_3_1_0_1_RightCurlyBracketKeyword_3_1_0_3__q.equals(syntax))
				emit_Peripheral___AxisPositionsKeyword_3_1_0_0_LeftCurlyBracketKeyword_3_1_0_1_RightCurlyBracketKeyword_3_1_0_3__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_Peripheral___DistancesKeyword_3_1_7_0_LeftCurlyBracketKeyword_3_1_7_1_RightCurlyBracketKeyword_3_1_7_3__q.equals(syntax))
				emit_Peripheral___DistancesKeyword_3_1_7_0_LeftCurlyBracketKeyword_3_1_7_1_RightCurlyBracketKeyword_3_1_7_3__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_Peripheral___LeftCurlyBracketKeyword_3_0_RightCurlyBracketKeyword_3_2__q.equals(syntax))
				emit_Peripheral___LeftCurlyBracketKeyword_3_0_RightCurlyBracketKeyword_3_2__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_Peripheral___PathsKeyword_3_1_8_0_LeftCurlyBracketKeyword_3_1_8_1_RightCurlyBracketKeyword_3_1_8_3__q.equals(syntax))
				emit_Peripheral___PathsKeyword_3_1_8_0_LeftCurlyBracketKeyword_3_1_8_1_RightCurlyBracketKeyword_3_1_8_3__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_Peripheral___SymbolicPositionsKeyword_3_1_1_0_LeftCurlyBracketKeyword_3_1_1_1_RightCurlyBracketKeyword_3_1_1_3__q.equals(syntax))
				emit_Peripheral___SymbolicPositionsKeyword_3_1_1_0_LeftCurlyBracketKeyword_3_1_1_1_RightCurlyBracketKeyword_3_1_1_3__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else acceptNodes(getLastNavigableState(), syntaxNodes);
		}
	}

	/**
	 * Ambiguous syntax:
	 *     ('PathAnnotations' '{' '}')?
	 *
	 * This ambiguous syntax occurs at:
	 *     (rule start) (ambiguity) (rule start)
	 *     (rule start) (ambiguity) peripheralTypes+=PeripheralType
	 *     (rule start) (ambiguity) resources+=Resource
	 *     imports+=Import (ambiguity) (rule end)
	 *     imports+=Import (ambiguity) peripheralTypes+=PeripheralType
	 *     imports+=Import (ambiguity) resources+=Resource
	 *     type=ID (ambiguity) (rule end)
	 *     type=ID (ambiguity) peripheralTypes+=PeripheralType
	 *     type=ID (ambiguity) resources+=Resource
	 */
	protected void emit_Machine___PathAnnotationsKeyword_3_0_LeftCurlyBracketKeyword_3_1_RightCurlyBracketKeyword_3_3__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Ambiguous syntax:
	 *     ('Actions' '{' '}')?
	 *
	 * This ambiguous syntax occurs at:
	 *     name=ID '{' (ambiguity) 'SetPoints' '{' '}' 'Axes' '{' '}' 'Conversion' conversion=STRING
	 *     name=ID '{' (ambiguity) 'SetPoints' '{' '}' 'Axes' '{' axes+=Axis
	 *     name=ID '{' (ambiguity) 'SetPoints' '{' setPoints+=SetPoint
	 *     name=ID '{' (ambiguity) ('SetPoints' '{' '}' 'Axes' '{' '}')? '}' (rule end)
	 */
	protected void emit_PeripheralType___ActionsKeyword_4_0_LeftCurlyBracketKeyword_4_1_RightCurlyBracketKeyword_4_3__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Ambiguous syntax:
	 *     (
	  *         'SetPoints' 
	  *         '{' 
	  *         '}' 
	  *         'Axes' 
	  *         '{' 
	  *         '}'
	  *     )?
	 *
	 * This ambiguous syntax occurs at:
	 *     actions+=ActionType '}' (ambiguity) '}' (rule end)
	 *     name=ID '{' ('Actions' '{' '}')? (ambiguity) '}' (rule end)
	 */
	protected void emit_PeripheralType___SetPointsKeyword_5_0_LeftCurlyBracketKeyword_5_1_RightCurlyBracketKeyword_5_3_AxesKeyword_5_4_LeftCurlyBracketKeyword_5_5_RightCurlyBracketKeyword_5_7__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Ambiguous syntax:
	 *     ('AxisPositions' '{' '}')?
	 *
	 * This ambiguous syntax occurs at:
	 *     type=[PeripheralType|ID] '{' (ambiguity) 'SymbolicPositions' '{' positions+=SymbolicPosition
	 *     type=[PeripheralType|ID] '{' (ambiguity) ('SymbolicPositions' '{' '}')? 'Profiles' '(' profiles+=Profile
	 */
	protected void emit_Peripheral___AxisPositionsKeyword_3_1_0_0_LeftCurlyBracketKeyword_3_1_0_1_RightCurlyBracketKeyword_3_1_0_3__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Ambiguous syntax:
	 *     ('Distances' '{' '}')?
	 *
	 * This ambiguous syntax occurs at:
	 *     profiles+=Profile ')' (ambiguity) 'Paths' '{' paths+=Path
	 *     profiles+=Profile ')' (ambiguity) ('Paths' '{' '}')? '}' (rule end)
	 */
	protected void emit_Peripheral___DistancesKeyword_3_1_7_0_LeftCurlyBracketKeyword_3_1_7_1_RightCurlyBracketKeyword_3_1_7_3__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Ambiguous syntax:
	 *     ('{' '}')?
	 *
	 * This ambiguous syntax occurs at:
	 *     type=[PeripheralType|ID] (ambiguity) (rule end)
	 */
	protected void emit_Peripheral___LeftCurlyBracketKeyword_3_0_RightCurlyBracketKeyword_3_2__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Ambiguous syntax:
	 *     ('Paths' '{' '}')?
	 *
	 * This ambiguous syntax occurs at:
	 *     distances+=Distance '}' (ambiguity) '}' (rule end)
	 *     profiles+=Profile ')' ('Distances' '{' '}')? (ambiguity) '}' (rule end)
	 */
	protected void emit_Peripheral___PathsKeyword_3_1_8_0_LeftCurlyBracketKeyword_3_1_8_1_RightCurlyBracketKeyword_3_1_8_3__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Ambiguous syntax:
	 *     ('SymbolicPositions' '{' '}')?
	 *
	 * This ambiguous syntax occurs at:
	 *     axisPositions+=AxisPositionsMapEntry '}' (ambiguity) 'Profiles' '(' profiles+=Profile
	 *     type=[PeripheralType|ID] '{' ('AxisPositions' '{' '}')? (ambiguity) 'Profiles' '(' profiles+=Profile
	 */
	protected void emit_Peripheral___SymbolicPositionsKeyword_3_1_1_0_LeftCurlyBracketKeyword_3_1_1_1_RightCurlyBracketKeyword_3_1_1_3__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
}
